# -*- coding: utf-8 -*-
"""
Created on Thu Mar  7 10:51:03 2013

@author: rob
"""
import PyTango
import types

def addMethod(class_obj, func_name, cmd_in):
    def proxy_command(class_obj,argin=None,tango_cmd=cmd_in):
        tango_dev = tango_cmd.split("->",1)[0]
        cmd_name = tango_cmd.split("->",1)[1]
        dev=PyTango.DeviceProxy(tango_dev)
        if argin is None:
            return dev.command_inout(cmd_name)
        else:
            return dev.command_inout(cmd_name,argin)
    return setattr(class_obj, func_name, types.MethodType(proxy_command, class_obj))
    

class ControlSystem(dict):
    """Example of overloading __getatr__ and __setattr__
    This example creates a dictionary where members can be accessed as attributes
    """
    def __init__(self,ATTRIBUTES_IN={},ATTRIBUTES_READONLY_IN={},COMMANDS_IN={}):
        self.ATTRIBUTES = ATTRIBUTES_IN
        self.ATTRIBUTES_READONLY = ATTRIBUTES_READONLY_IN
        self.COMMANDS = COMMANDS_IN
        indict = {}
        dict.__init__(self, indict)
        self.__initialised = True
        for cmd in COMMANDS_IN:
            tokens = COMMANDS_IN[cmd].split("|")
            tango_name = tokens[0]
            addMethod(self,cmd,tango_name)
        # after initialisation, setting attributes is the same as setting an item
        

    def __getattr__(self, item):
        """Maps values to attributes.
        Only called if there *isn't* an attribute with this name
        """
        if item in self.ATTRIBUTES:
            tokens = self.ATTRIBUTES[item].split("|")
            tango_name = tokens[0]
        elif item in self.ATTRIBUTES_READONLY:
            tokens = self.ATTRIBUTES_READONLY[item].split("|")
            tango_name = tokens[0]
        else:
             return
        try:
            attr_proxy = PyTango.AttributeProxy(tango_name)
            val = attr_proxy.read().value
        except:
            return None
        return val

    def __setattr__(self, item, value):
        """Maps attributes to values.
        Only if we are initialised
        """
        if not self.__dict__.has_key('_ControlSystem__initialised'):  # this test allows attributes to be set in the __init__ method
            return dict.__setattr__(self, item, value)
        elif self.__dict__.has_key(item):       # any normal attributes are handled normally
            print item,value
            dict.__setattr__(self, item, value)
        elif item in self.COMMANDS:
            dict.__setattr__(self, item, value)
        else:
            tokens = self.ATTRIBUTES[item].split("|")
            tango_name = tokens[0]
            attr_proxy = PyTango.AttributeProxy(tango_name)
            attr_proxy.write(value)

